
// NumberTypes.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, April 2023

/* Print details about Java's built-in math-related types:

   Usage:
     > compile NumberTypes.java
     > run NumberTypes
*/


import java.math.*;


public class NumberTypes 
{
  public static void main(String[] args) 
  {
    System.out.println(Byte.TYPE + ": " + Byte.SIZE + " bits");
    System.out.println("Range: " + Byte.MIN_VALUE + " to " + Byte.MAX_VALUE);
    System.out.println();
    
    System.out.println(Short.TYPE + ": " + Short.SIZE);
    System.out.println(Short.MIN_VALUE + " to " + Short.MAX_VALUE);
    System.out.println();
    
    System.out.println(Character.TYPE + ": " + Character.SIZE);
    System.out.println((int) Character.MIN_VALUE + " to " + (int) Character.MAX_VALUE);
    System.out.println();
    
    System.out.println(Integer.TYPE + ": " + Integer.SIZE);
    System.out.println(Integer.MIN_VALUE + " to " + Integer.MAX_VALUE);
    System.out.println();

    System.out.println(Long.TYPE + ": " + Long.SIZE);
    System.out.println(Long.MIN_VALUE + " to " + Long.MAX_VALUE);
    System.out.println();
    
    System.out.println(Float.TYPE + ": " + Float.SIZE);
    System.out.println(Float.MIN_VALUE + " to " + Float.MAX_VALUE);
    System.out.println();
    
    System.out.println(Double.TYPE + ": " + Double.SIZE);
    System.out.println(Double.MIN_VALUE + " to " + Double.MAX_VALUE);
    System.out.println();
  }  // end of main()

}  // end of NumberTypes class
